Unit SWCPGX;

{$F+$D+}

Interface

Uses CRT,
     DOS,
     SWCVaria;

Procedure ChangeRecSize(Name: ST08;Diff: IntL);
Procedure Cursor(Name: ST08;IndexField: Word;BClr,BBlock: Bool);
Procedure FillField(Name: ST08;IndexField: IntM;FillStr: STFF);
Procedure Format(Name: ST08;FIndex: IntM;Mode: Byte);
Function  Format2(Name: ST08;FIndex: Word;FStr: STFF): STFF;
Procedure FromUpto(Name: ST08;Var From,Upto: IntL);
Procedure FullLine(Name: ST08;IndexField: Word);
Procedure FullLine2(Name: ST08;IndexField: Word;BEx: Bool);
Function  GetCountPGXFields(Name: ST08): Word;
Function  GetDirPathFromName(Name: ST08): ST67;
Function  GetFieldByte(Name: ST08;IndexField: Word): Byte;
Function  GetFieldInt(Name: ST08;IndexField: Word): IntM;
Function  GetFieldLong(Name: ST08;IndexField: Word): IntL;
Function  GetFieldReal(Name: ST08;IndexField: Word): Real;
Function  GetFieldStr(Name: ST08;IndexField: Word;Mode: Byte): STFF;
Function  GetFieldWord(Name: ST08;IndexField: Word): Word;
Function  GetFieldFromFile(Name: ST08;MskName: ST08;
          NameRec: ST79;IDXStr: ST79;BMove: Bool;
          IndexRec: IntL;IndexField: Word): STFF;
Procedure GetFieldInfo(Name: ST08);
Function  GetFormat(Name: ST08;FIdx: Word): Byte;
Procedure GetVectors(Name: ST08);
Function  LastRec(Name: ST08) : IntL;
Procedure LoadNoRec(Name: ST08);
Procedure LoadRec(Name: ST08;BScreen: Bool);
Procedure MoveColToScreen(Name: ST08;XPos,YPos,Len: Word;Col: Byte);
Procedure MoveEditorfieldToRec(Name: ST08;Indexfield: Word);
Procedure MoveEditorfieldToScreen(Name: ST08;IndexField: Word);
Procedure MoveRecToEditorfield(Name: ST08;IndexField: Word);
Procedure MoveRecToFile(NameS: ST08;Var MFileD,MFileI: Hand);
Procedure MoveRecToRec(NameS,NameT: ST08);
Procedure MoveRecToScreen(Name: ST08);
Function  MoveScreenToTXT(Name: ST08;XP,YP,XW: Word;BBuendig: Bool): STFF;
Procedure MoveTxtToScreen(Name: ST08;XPos,YPos: Word;TTXT: STFF);
Procedure PageMask(Name: ST08; ByteH,ByteV: Byte);
Procedure PageMask2(Name: ST08;IField: Word);
Procedure Patterns(Name: ST08;ColChar: Word);
Procedure PGXEdit(Name: ST08;MskName: ST08;
          NameRec: ST79;IdxStr: ST79;
          Byte_H,Byte_V: Byte;
          Bool13Ex: Bool;IndexF: IntM;
          BoolFree: Bool;BoolClr: Bool);
Procedure PGXFree(Name: ST08);
Function  PGXIGet(Name: ST08): Byte;
Procedure PGXIni;
Procedure PGXLoad(Name: ST08;MskName: ST08;
          NameRec: ST79;IdxStr: ST79;IndexF: IntM;FMode: Byte);
Procedure PGXPress(Name: ST08;Index: IntM);
Function  PGXSearch(Name: ST08;FNum: IntM;SStr: ST80): IntL;
Function  PGXSearchJ(Name: ST08;FNum: IntM;SStr: ST80): IntL;
Function  PGXStr(Name: ST08): ST01;
Function  PGXTest(Name: ST08): Bool;
Procedure RecAnf(NameS,NameT: ST08);
Procedure RecDel(Name: ST08;BAsk: Bool);
Procedure RecIns(Name: ST08;BAsk: Bool);
Procedure RecVor(Name: ST08);
Procedure RecVor1(Name: ST08);
Procedure RecVorF(Name: ST08;Upto: IntL);
Procedure RecVorT(Name: ST08;Upto: IntL);
Procedure RecVorX(Name: ST08;Upto: IntL);
Procedure RecZur(Name: ST08);
Procedure SaveRec(Name: ST08;BSave: Bool);
Procedure SaveRecMove(Name: ST08);
Function  SearchRec(Name: ST08;I0,I1,I2,I3,I4: IntM;
          T0,T1,T2,T3,T4: ST80;LongI: IntL;BAll: Bool): IntL;
Procedure ShadowPGX(Name: ST08);
Procedure TempIn(Name: ST08);
Procedure TempOut(Name: ST08);
Procedure WriteIndexRec(Name: ST08);
Procedure WriteVRam(Name: ST08;VStr: STFF;VMod: Bool);


Implementation


Uses SWCFNB,
     SWCMask,
     SWCMskIf,
     SWCMskPX,
     SWCOpt,
     SWCPGXE,
     SWCSubPr;



Procedure LoadRecMove(Name: ST08);                          Forward;
Procedure SearchRec2(Name: ST08;I0,I1,I2,I3,I4: IntM;
          T0,T1,T2,T3,T4: ST80;LongX: IntL;Var BErr: Bool); ForWard;



Procedure ChangeRecSize(Name: ST08;Diff: IntL);
Var
  I      : Byte;
  NSize  : IntL;
  TMPSel : Word;
  Word0  : Word;
  Word1  : Word;

Begin

  If Diff<>000 Then
  Begin
    I:=PGXIGet(Name);
    NSize:=RecSize[I]+Diff;
    TMPSel:=GetBuf(NSize,Word0,Word1);
    MemErrorOut('ChangeRecSize ('+NamLst[I]+') (1)',Word0,000);
    If Diff>000 Then
    Move(Mem[RecSel[I]:0],Mem[TMPSel:0],RecSize[I])
    Else
    Move(Mem[RecSel[I]:0],Mem[TMPSel:0],NSize);
    FreeBuf(RecSel[I],Word0);
    MemErrorOut('ChangeRecSize ('+NamLst[I]+') (2)',Word0,000);
    Move(TMPSel,RecSel[I],002);
    RecSizeVor[I]:=NSize;
    RecSize[I]:=NSize;
  End;

End;




Procedure Cursor(Name: ST08;IndexField: Word;BClr,BBlock: Bool);
Begin

  ECursor(Name,IndexField,BClr,BBlock);

End;




Procedure FillField(Name: ST08;IndexField: IntM;FillStr: STFF);
Var
  Temp : STFF;

Begin

  Temp:=EditorField;
  MoveRecToEditorfield(Name,IndexField);
  EditorField:=FillStr;
  MoveEditorfieldToRec(Name,IndexField);
  EditorField:=Temp;

End;




Procedure Format(Name: ST08;FIndex: IntM;Mode: Byte);
Var
  Byte0 : Byte;
  I     : Byte;
  Long0 : IntL;
  Real0 : Real;

Begin

  I:=PGXIGet(Name);
  If Name='CNVEDI'   Then Mode:=128;
  If Name='PRNTLST'  Then Mode:=000;
  If Name='SORTPGX'  Then Mode:=128;
  If Name='PRNSRT'   Then Mode:=128;
  If Name='IMPORTF'  Then Mode:=005;
  If Name='EDIFORDR' Then Mode:=000;
  If Name='PGXEXPFN' Then Mode:=000;
  If Name='PGXEXPFI' Then Mode:=005;
  MoveMemToVec(I,FIndex);
  With VecRec[I] Do
  Begin
    Case Mode And 015 Of
    000 : EditorField:=BuendigLR(EditorField);
    001 : EditorField:=BuendigR(Name,FIndex,EditorField);
    002 : Begin
          End;
    003 : Begin
            EditorField:=BuendigLR(EditorField);
            If EditorField<>'' Then
            Begin
              Byte0:=Pos(',',EditorField);
              If Byte0>000 Then EditorField[Byte0]:=#046;
              Val(EditorField,Real0,ValCode);
              If ValCode=000 Then
              Str(Real0:LenTab:002,EditorField)
              Else EditorField:='';
            End;
          End;
    004 : Begin
            EditorField:=BuendigLR(EditorField);
            If EditorField<>'' Then
            Begin
              Byte0:=Pos(',',EditorField);
              If Byte0>000 Then EditorField[Byte0]:=#046;
              Byte0:=Pos('.',EditorField);
              Val(EditorField,Real0,ValCode);
              If Byte0>000 Then
              Begin
                If ValCode=000 Then
                Str(Real0:LenTab:
                Length(EditorField)-Byte0,EditorField)
                Else EditorField:='';
              End
              Else
              Begin
                If ValCode=000 Then
                Str(Real0:LenTab:000,EditorField)
                Else EditorField:='';
              End
            End;
          End;
    005 : Begin
            EditorField:=BuendigLR(EditorField);
            If EditorField<>'' Then
            Begin
              Val(EditorField,Long0,ValCode);
              If ValCode=000 Then Str(Long0:LenTab,EditorField)
              Else EditorField:='';
            End;
          End;
    007 : If Boolean13 Then
          Begin
            EditorField:=FillString(EditorField,#044,#046);
            EditorField:=MakeTime(BuendigLR(EditorField));
          End;
    010 : Begin {Whrungsfeld}
            EditorField:=BuendigLR(EditorField);
            If EditorField<>'' Then
            Begin
              Byte0:=Pos(',',EditorField);
              If Byte0>000 Then EditorField[Byte0]:=#046;
              Val(EditorField,Real0,ValCode);
              If ValCode=000 Then
              Str(Real0:LenTab:002,EditorField)
              Else EditorField:='';
            End;
          End;
    End;
    If Mode And 128=128 Then
    EditorField:=UpCaseStr(EditorField);
  End;

End;




Function  Format2(Name: ST08;FIndex: Word;FStr: STFF): STFF;
Var
  Byte0 : Byte;
  I     : Byte;
  Long0 : IntL;
  Real0 : Real;
  Word0 : Word;

Begin

  I:=PGXIGet(Name);
  MoveMemToVec(I,FIndex);
  With VecRec[I] Do
  Begin
    If Name='PGXEXPFI' Then FMode:=005;
    Case FMode And 015 of
    000 : FStr:=BuendigLR(FStr);
    001 : FStr:=BuendigR(Name,FIndex,FStr);
    002 : Begin
          End;
    003 : Begin
            FStr:=BuendigLR(FStr);
            If FStr<>'' Then
            Begin
              Byte0:=Pos(',',FStr);
              If Byte0>000 Then FStr[Byte0]:=#046;
              Val(FStr,Real0,ValCode);
              If ValCode=000 Then Str(Real0:LenTab:002,FStr)
              Else FStr:='';
            End;
          End;
    004 : Begin
            FStr:=BuendigLR(FStr);
            If FStr<>'' Then
            Begin
              Byte0:=Pos(',',FStr);
              If Byte0>000 Then FStr[Byte0]:=#046;
              Byte0:=Pos('.',FStr);
              Val(FStr,Real0,ValCode);
              If Byte0>000 Then
              Begin
                If ValCode=000 Then
                Str(Real0:LenTab:Length(FStr)-Byte0,FStr)
                Else FStr:='';
              End
              Else
              Begin
                If ValCode=000 Then
                Str(Real0:LenTab:000,FStr)
                Else FStr:='';
              End
            End;
          End;
    005 : Begin
            FStr:=BuendigLR(FStr);
            If FStr<>'' Then
            Begin
              Val(FStr,Long0,ValCode);
              If ValCode=000 Then Str(Long0:LenTab,FStr)
              Else FStr:='';
            End;
          End;
    007 : FStr:=MakeTime(FStr);
    010 : Begin
            FStr:=BuendigLR(FStr);
            If FStr<>'' Then
            Begin
              Byte0:=Pos(',',FStr);
              If Byte0>000 Then FStr[Byte0]:=#046;
              Val(FStr,Real0,ValCode);
              If ValCode=000 Then Str(Real0:LenTab:002,FStr)
              Else FStr:='';
            End;
          End;
    End;
    If FMode And 128=128 Then
    FStr:=UpCaseStr(FStr);
  End;
  Format2:=FStr;

End;




Procedure FromUpto(Name: ST08;Var From,UpTo: IntL);
Var
  Word0 : Word;

Begin

  WaitClr;
  From:=000;
  UpTo:=LastRec(Name);
  Boolean13:=BT;
  Exit;

  Repeat
    PGXEdit('FROMUPTO','FROMUPTO',
    PRGPATH+'\DATS\FROMUPTO.DAT','',030,005,BT,000,BF,BT);
    If booleanex Then
    Begin
      PGXFree('FROMUPTO');
      Exit;
    End;
    from:=GetFieldLong('FROMUPTO',000);
    upto:=GetFieldLong('FROMUPTO',001);
    PGXFree('FROMUPTO');
    Dec(from);Dec(upto);
    booleanerr:=true;
    If  (from>=000)
    And (upto>=000)
    And (from<=upto)
    And (upto<=LastRec(name)) Then booleanerr:=false;
  Until Not booleanerr;

End;




Procedure FullLine(name: ST08;indexfield: Word);
Const
  cursr : Array[000..PGX] Of Byte=(0,0,0,0,0,0,0,0,0,0,0,0);
  winx1 : Array[000..PGX] Of Byte=(0,0,0,0,0,0,0,0,0,0,0,0);
  winx2 : Array[000..PGX] Of Byte=(0,0,0,0,0,0,0,0,0,0,0,0);
  winy1 : Array[000..PGX] Of Byte=(0,0,0,0,0,0,0,0,0,0,0,0);
  winy2 : Array[000..PGX] Of Byte=(0,0,0,0,0,0,0,0,0,0,0,0);
  cposx : Array[000..PGX] Of Byte=(0,0,0,0,0,0,0,0,0,0,0,0);
  cposy : Array[000..PGX] Of Byte=(0,0,0,0,0,0,0,0,0,0,0,0);
  col   : Array[000..PGX] Of Byte=(0,0,0,0,0,0,0,0,0,0,0,0);
  temp  : Array[000..PGX] Of STA0=('','','','','','','','','','','','');

Var
  Byte0 : Byte;
  I     : Byte;
  str0  : ST80;

Begin

  I:=PGXIGet(Name);
  MoveMemToVec(I,indexfield);
  With vecrec[I] Do
  Begin
    If poschr[I]<=lentab then
    Begin
      If Not booleanfullline[I] Then Exit;
      booleanfullline[I]:=false;
      PageMask2(name,indexfield);
      str0:=editorfield;
      WriteIndexRec(name);
      editorfield:=str0;
      window(winx1[I]+001,
      winy1[I]+001,winx2[I]+001,winy2[I]+001);
      ClrScr(col[I]);
      gotoxy(cposx[I],cposy[I]);
      WriteVRam(name,editorfield,screen_fmode[I]);
      If winy1[I]<012 Then
      For Byte0:=000 to 159 do
      Mem[SegB800:screen_yend[I]*160+Byte0]:=Ord(temp[I][Byte0])
      Else
      For Byte0:=000 to 159 do
      Mem[SegB800:Byte0]:=Ord(temp[I][Byte0]);
      poscur[I]:=cursr[I];
      posstr[I]:=001;
      Exit;
    End;
    If Not booleanfullline[I] Then
    Begin
      col[I]:=TextAttr;
      cursr[I]:=poscur[I];
      cposx[I]:=wherex;
      cposy[I]:=wherey;
      winx1[I]:=lo(windmin);
      winy1[I]:=hi(windmin);
      winx2[I]:=lo(windmax);
      winy2[I]:=hi(windmax);
      booleanfullline[I]:=BT;
      If winy1[I]<012 Then
      For Byte0:=000 to 159 do
      temp[I][Byte0]:=Chr(Mem[SegB800:screen_yend[I]*160+Byte0])
      Else
      For Byte0:=000 to 159 do
      temp[I][Byte0]:=Chr(Mem[SegB800:Byte0]);
    End;
    If winy1[I]<012 Then
    Begin
      Window(001,screen_yend[I]+001,080,screen_yend[I]+001);
      ClrScr(064+014);
    End
    Else
    Begin
      Window(001,001,080,001);
      ClrScr(064+014);
    End;
    WriteVRam(name,editorfield,true);
    GotoXY(poschr[I],001);
  End;

End;




Procedure FullLine2(Name: ST08;IndexField: Word;BEx: Bool);
Begin

  EFullLine2(Name,IndexField,BEx);

End;




Function  GetCountPGXFields(Name: ST08): Word;
Var
  cntrf : Word;
  cntrw : Word;
  color : Byte;
  I     : Byte;
  maxfl : Word;
  maxii : Word;
  width : Word;
  Wordi : Word;

Begin

  cntrf:=000;
  cntrw:=000;
  Wordi:=000;
  I:=PGXIGet(Name);
  color:=screen_fcolor[I];
  width:=screen_width[I];
  maxii:=screen_width[I]*screen_height[I];
  Repeat
    If Mem[screen_sel[I]:Wordi*002+001]=color Then
    Begin
      Inc(cntrf);
      Inc(cntrw);
      Inc(Wordi);
      While (Mem[screen_sel[I]:Wordi*002+001]=color)
      And (cntrw<width) Do
      Begin
        Inc(cntrw);
        Inc(Wordi);
      End;
    End
    Else
    Begin
      Inc(Wordi);
      Inc(cntrw);
    End;
    If cntrw=width Then cntrw:=000;
  Until Wordi=maxii;
  GetCountPGXFields:=cntrf;

End;




Function  GetDirPathFromName(Name: ST08): ST67;
Var
  Byte0 : Byte;
  DStr  : ST67;
  EStr  : ST04;
  NStr  : ST08;

Begin

  For Byte0:=000 To PGX Do
  If NamLst[Byte0]=Name Then
  Begin
    FSplit(PGXDPath[Byte0],DStr,NStr,EStr);
    GetDirPathFromName:=DStr;
    Exit;
  End;
  ErrorOut('GetDirPathFromName: Name '+
  Name+' nicht gefunden',001,'',#000);

End;




Function  GetFieldByte(name: ST08;indexfield: Word): Byte;
Var
  Byte0 : Byte;

Begin

  MoveRecToEditorfield(name,indexfield);
  Val(editorfield,Byte0,VALCODE);
  GetFieldByte:=Byte0;

End;




Function  GetFieldInt(name: ST08;indexfield: Word): IntM;
Var
  int0 : IntM;

Begin

  MoveRecToEditorfield(name,indexfield);
  Val(editorfield,int0,VALCODE);
  GetFieldInt:=int0;

End;




Function  GetFieldLong(name: ST08;indexfield: Word): IntL;
Var
  long0 : IntL;

Begin

  MoveRecToEditorfield(name,indexfield);
  Val(editorfield,long0,VALCODE);
  GetFieldLong:=long0;

End;




Function  GetFieldReal(Name: ST08;IndexField: Word): Real;
Var
  Real0 : Real;

Begin

  MoveRecToEditorfield(Name,IndexField);
  Val(EditorField,Real0,VALCODE);
  If ValCode=000 Then GetFieldReal:=Real0
  Else
  If EditorField[ValCode]=#247 Then
  Begin
    Val(Copy(EditorField,ValCode+001,
    Length(EditorField)-ValCode),Real0,VALCODE);
    GetFieldReal:=Real0;
  End
  Else
  GetFieldReal:=000;

End;




Function  GetFieldStr(name: ST08;indexfield: Word;mode: Byte): STFF;
Begin

  MoveRecToEditorfield(name,indexfield);
  Format(name,indexfield,mode);
  GetFieldStr:=editorfield;

End;




Function  GetFieldFromFile(Name: ST08;MskName: ST08;
          NameRec: ST79;IDXStr: ST79;BMove: Bool;
          IndexRec: IntL;IndexField: Word): STFF;
Begin

  PGXLoad(Name,MskName,NameRec,IDXStr,IndexField,000);
  If BMove Then RecVorF(Name,IndexRec)
  Else
  LoadRec(Name,BF);
  GetFieldFromFile:=GetFieldStr(Name,IndexField,002);
  PGXFree(Name);

End;




Procedure GetFieldInfo(Name: ST08);
Var
  I     : Byte;
  Word0 : Word;

Begin

  I:=PGXIGet(Name);
  GetIPtr(I,IndexPGX[I]);
  If (Pos('LSTSRC',Name)>000)
  Or (Pos('CHNGFMS',Name)>000)
  Or (Pos('PRNTLST',Name)>000)
  Or (Pos('SORTPGX',Name)>000)
  Or (Pos('MAKEFNAM',Name)>000) Then
  Begin
    With VecRec[I] Do
    For Word0:=000 To PGXUpTo[I] Do
    Begin
      MoveMemToVec(I,Word0);
      FMode:=032;
      MoveVecToMem(I,Word0);
    End;
  End
  Else
  If Pos('LSTSRT',Name)>000 Then
  Begin
    With VecRec[I] Do
    For Word0:=000 To PGXUpTo[I] Do
    Begin
      MoveMemToVec(I,Word0);
      FMode:=128;
      MoveVecToMem(I,Word0);
    End;
  End;

End;




Function  GetFieldWord(name: ST08;indexfield: Word): Word;
Var
  Word0 : Word;

Begin

  MoveRecToEditorfield(name,indexfield);
  Val(editorfield,Word0,VALCODE);
  GetFieldWord:=Word0;

End;




Function  GetFormat(Name: ST08;FIdx: Word): Byte;
Var
  I : Byte;

Begin

  I:=PGXIGet(Name);
  MoveMemToVec(I,FIdx);
  With VecRec[I] Do GetFormat:=FMode;

End;




Procedure GetVectors(Name: ST08);
Label GVCOMPR2,
      GVCOMPR22,
      GVCOMPR31,
      GVCOMPR32,
      GVCOMPR4,
      GVCOMPR5,
      GVCOMPR6;

Var
  FAdr  : Word;
  FLen  : Byte;
  I     : Byte;
  FIdx  : Word;
  LIdx  : Word;
  ScanL : Word;

Procedure HelpScannLine;
Begin
  If ScanL>Screen_Width[I] then
  Begin
    Inc(LIdx);
    ScanL:=001;
  End;
End;

Begin

  I:=PGXIGet(Name);
  If Not Screen_FMode[I] Then
  Begin
    FAdr:=000; {Diesen Teil der Prozedur habe ich verbessert}
    FIdx:=000; {So programmiere ich heute (05.06.2000)      }
    LIdx:=001;
    ScanL:=001;
    Repeat
      If Mem[Screen_Sel[I]:FAdr*002+001]<>Screen_FColor[I] then
      Begin
        Inc(FAdr);
        Inc(ScanL);
        HelpScannLine;
      End
      Else
      Begin
        FLen:=000;
        While (Mem[Screen_Sel[I]:FAdr*002+001]=Screen_FColor[I])
        And   (ScanL+FLen<=Screen_Width[I]) And (FLen<=079) Do
        Begin
          Inc(FAdr);
          Inc(FLen);
        End;
        Dec(FLen,002);
        If  (FLen>=001)
        And (FLen<=078) Then
        Begin
          With VecRec[I] do
          Begin
            LenTab:=FLen;
            YTab  :=LIdx;
            X1Tab :=ScanL+001;
            X2Tab :=ScanL+FLen-001;
            OfsTab:=(FAdr-FLen)*002;
          End;
          MoveVecToMem(I,FIdx);
          Inc(FIdx);
          If FIdx<=4095 then
          Begin
            ScanL:=ScanL+FLen+002;
            HelpScannLine;
          End
          Else
          ErrorOut('GetVectors: '+Name+': Zuviele Felder',001,'',#000);
        End
        Else
        ErrorOut('GetVectors: '+Name+
        ': Felder zu kurz oder lang',001,'',#000);
      End;
    Until FAdr>=Screen_Width[I]*Screen_Height[I];
    If FIdx>=001 Then
    PGXUpTo[I]:=FIdx-001
    Else
    ErrorOut('GetVectors: '+Name+': Keine Felder gefunden',001,'',#000);
  End
  Else
  Begin
    FAdr:=000; {So habe ich anfangs programmiert}
    FIdx:=000;
    LIdx:=001;
    ScanL:=001;
    GVCOMPR2:
    If Mem[Screen_Sel[I]:FAdr*002+001]=Screen_FColor[I] Then Goto GVCOMPR4;
    Inc(FAdr);
    Inc(ScanL);
    GVCOMPR22:
    HelpScannLine;
    If FAdr<Screen_Width[I]*Screen_Height[I] Then Goto GVCOMPR2;
    If FIdx=000 then
    ErrorOut('GetVectors: Keine Felder gefunden: '+name,001,'',#000);
    Exit;
    GVCOMPR4:
    FLen:=000;
    GVCOMPR5:
    If Mem[Screen_Sel[I]:FAdr*002+001]<>Screen_FColor[I] Then Goto GVCOMPR6;
    If ScanL+FLen>Screen_Width[I] Then Goto GVCOMPR6;
    If FLen>081 Then Goto GVCOMPR6;
    Inc(FLen);
    Inc(FAdr);
    Goto GVCOMPR5;
    GVCOMPR6:
    With VecRec[I] Do
    Begin
      LenTab:=FLen;
      YTab  :=LIdx;
      X1Tab :=ScanL;
      X2Tab :=ScanL+FLen-001;
      OfsTab:=(FAdr-FLen)*002;
    End;
    MoveVecToMem(I,FIdx);
    PGXUpTo[I]:=FIdx;
    Inc(FIdx);
    If FIdx>4095 Then
    ErrorOut('GetVectors: Zuviele Felder: '+Name,001,'',#000);
    ScanL:=ScanL+FLen;
    If ScanL>Screen_Width[I] Then Goto GVCOMPR22;
    If FAdr<Screen_Width[I]*Screen_Height[I] Then Goto GVCOMPR2;
  End;

End;




Procedure GetVectors2(Name: ST08);
Label gv1,
      gv2,
      gv22,
      gv31,
      gv32,
      gv33,
      gv4,
      gv5,
      gv6,
      gvcompr,
      gvcompr2,
      gvcompr22,
      gvcompr31,
      gvcompr32,
      gvcompr4,
      gvcompr5,
      gvcompr6;
Var
  adressmem   : Word;
  fieldlength : Byte;
  I           : Byte;
  indexfield  : Word;
  indexline   : Word;
  scannline   : Word;

Begin

  I:=PGXIGet(Name);
  if screen_fmode[I] then goto gvcompr;

  gv1:
  adressmem  :=$0000;
  scannline  :=$0001;
  indexfield :=000;
  indexline  :=$0001;

  gv2:
  if mem[screen_sel[I]:adressmem*002+001]=
  screen_fcolor[I] then goto gv4;
  inc(adressmem);
  inc(scannline);

  gv22:
  if scannline>screen_width[I] then
  begin
    scannline:=001;
    inc(indexline);
  end;
  if adressmem<screen_width[I]*screen_height[I] then goto gv2;
  if indexfield=000 then goto gv31;
  Exit;

  gv31:
  ErrorOut('GetVectors: Keine Felder gefunden: '+name,001,'',#000);
  gv32:
  ErrorOut('GetVectors: Felder zu kurz oder lang: '+name,001,'',#000);
  gv33:
  ErrorOut('GetVectors: Zuviele Felder: '+name,001,'',#000);

  gv4:
  fieldlength:=000;

  gv5:
  if mem[screen_sel[I]:adressmem*002+001]<>
  screen_fcolor[I] then goto gv6;
  if scannline+fieldlength>screen_width[I] then goto gv6;
  if fieldlength>079 then goto gv6;
  inc(fieldlength);
  inc(adressmem);
  goto gv5;

  gv6:
  dec(fieldlength,002);
  if (fieldlength<001)
  or (fieldlength>078) then goto gv32;
  With vecrec[I] do
  Begin
    lentab:=fieldlength;
    ytab  :=indexline;
    x1tab :=scannline+001;
    x2tab :=scannline+fieldlength-001;
    ofstab:=(adressmem-fieldlength)*002;
  End;
  MoveVecToMem(I,indexfield);
  PGXUpTo[I]:=indexfield;
  inc(indexfield);
  if indexfield>4096 then goto gv33;
  scannline:=scannline+fieldlength+002;
  if scannline>screen_width[I] then goto gv22;
  if adressmem<screen_width[I]*screen_height[I] then goto gv2;
  Exit;

  {***********************************************************************}

  gvcompr:
  adressmem  :=$0000;
  scannline  :=$0001;
  indexfield :=000;
  indexline  :=$0001;

  gvcompr2:
  if mem[screen_sel[I]:adressmem*002+001]=
  screen_fcolor[I] then goto gvcompr4;
  inc(adressmem);
  inc(scannline);

  gvcompr22:
  if scannline>screen_width[I] then
  begin
    scannline:=001;
    inc(indexline);
  end;
  if adressmem<screen_width[I]*screen_height[I] then goto gvcompr2;
  if indexfield=000 then goto gvcompr31;
  Exit;

  gvcompr31:
  ErrorOut('GetVectors: Keine Felder gefunden: '+name,001,'',#000);
  gvcompr32:
  ErrorOut('GetVectors: Zuviele Felder: '+name,001,'',#000);

  gvcompr4:
  fieldlength:=000;

  gvcompr5:
  if mem[screen_sel[I]:adressmem*002+001]<>
  screen_fcolor[I] then goto gvcompr6;
  if scannline+fieldlength>screen_width[I] then goto gvcompr6;
  if fieldlength>081 then goto gvcompr6;
  inc(fieldlength);
  inc(adressmem);
  goto gvcompr5;

  gvcompr6:
  With vecrec[I] do
  Begin
    lentab:=fieldlength;
    ytab  :=indexline;
    x1tab :=scannline;
    x2tab :=scannline+fieldlength-001;
    ofstab:=(adressmem-fieldlength)*002;
  End;
  MoveVecToMem(I,indexfield);
  PGXUpTo[I]:=indexfield;
  inc(indexfield);
  if indexfield>4096 then goto gvcompr32;
  scannline:=scannline+fieldlength;
  if scannline>screen_width[I] then goto gvcompr22;
  if adressmem<screen_width[I]*screen_height[I] then goto gvcompr2;
End;




Function LastRec(Name: ST08) : IntL;
Var
  I : Byte;

Begin

  I:=PGXIGet(Name);
  If BooleanMove[I] Then
  LastRec:=FileSize(PGXIHandle[I])-001
  Else
  LastRec:=000;

End;




Procedure LoadNoRec(name: ST08);
Var
  I     : Byte;
  Word1 : Word;
  Word2 : Word;

Begin

  I:=PGXIGet(Name);
  recsizevor[I]:=(PGXUpTo[I]+001)*002;
  recsize[I]:=(PGXUpTo[I]+001)*002;
  For Word1:=000 To PGXUpTo[I] Do
  MemW[recsel[I]:Word1*002]:=$0a0d;
  Word1:=000;
  Word2:=00000;
  Repeat
    MoveMemToVec(I,Word1);
    With vecrec[I] Do recofs:=Word2;
    MoveVecToMem(I,Word1);
    repeat
      Inc(Word2);
    until (mem[recsel[I]:Word2]=010)
    or (Word2>recsize[I]);
    if mem[recsel[I]:Word2]=010 then Inc(Word1);
    Inc(Word2);
  until Word1>PGXUpTo[I];
  MoveRecToScreen(name);

End;




Procedure LoadRec(Name: ST08;BScreen: Bool);
Var
  BErr  : Bool;
  Byte0 : Byte;
  I     : Byte;
  Word0 : Word;
  Word1 : Word;

Begin

  I:=PGXIGet(Name);
  If Not BooleanMove[I] Then
  Begin
    BooleanErr:=BF;
    Repeat
      BErr:=BF;
      Seek(PGXDHandle[I],000);
      If RecSize[I]<FileSize(PGXDHandle[I]) Then
      ChangeRecSize(Name,FileSize(PGXDHandle[I])-RecSize[I])
      Else
      ChangeRecSize(Name,RecSize[I]-FileSize(PGXDHandle[I]));
      BlockRead(PGXDHandle[I],Mem[RecSel[I]:0],
      FileSize(PGXDHandle[I]),CntrHROW0);
      Word0:=000;
      For Word1:=000 To PGXUpTo[I] Do
      Begin
        If Not BErr Then
        Begin
          MoveMemToVec(I,Word1);
          With VecRec[I] Do RecOfs:=Word0;
          MoveVecToMem(I,Word1);
          Byte0:=000;
          While (MemW[RecSel[I]:Word0]<>$0A0D)
          And (Word0<=RecSize[I])
          And (Byte0<081) Do
          Begin
            Inc(Byte0);
            Inc(Word0);
          End;
          If Byte0>080 Then
          Begin
            BErr:=BT;
          End
          Else
          If Word0>RecSize[I] Then
          Begin
            BErr:=BT;
          End;
          Inc(Word0,002);
        End;
      End;
    Until Not BErr;
  End
  Else
  LoadRecMove(Name);
  If BScreen Then
  MoveRecToScreen(Name);

End;




Procedure LoadRecMove(Name: ST08);
Begin

  ELoadRecMove(Name);

End;




Procedure MoveColToScreen(Name: ST08;XPos,YPos,Len: Word;Col: Byte);
Var
  Byte0 : Byte;
  I     : Byte;

Begin

  I:=PGXIGet(Name);
  For Byte0:=000 To Len-001 Do
  Mem[Screen_Sel[I]:YPos*002*Screen_Width[I]+
  XPos*002+Byte0*002+001]:=Col;

End;




Procedure MoveEditorfieldToRec(Name: ST08;IndexField: Word);
Var
  Byte0 : Byte;
  Byte1 : Byte;
  Byte2 : Byte;
  I     : Byte;
  RSize : Word;
  Word0 : Word;
  Word1 : Word;

Begin

  I:=PGXIGet(Name);
  RSize:=RecSize[I];
  MoveMemToVec(I,IndexField);
  With VecRec[I] Do Word0:=RecOfs;
  Byte0:=000;
  While Mem[RecSel[I]:Word0+Byte0]<>013 Do Inc(Byte0);
  Byte1:=Length(EditorField);
  If Byte0>Byte1 Then
  Begin
    Byte2:=Byte0-Byte1;
    Move(Mem[RecSel[I]:Word0+Byte0],
    Mem[RecSel[I]:Word0+Byte0-Byte2],
    RecSize[I]-(Word0+Byte0));
    For Word1:=IndexField+001 To PGXUpTo[I] Do
    Begin
      MoveMemToVec(I,Word1);
      With VecRec[I] Do Dec(RecOfs,Byte2);
      MoveVecToMem(I,Word1);
    End;
    ChangeRecSize(Name,Byte2*-001);
  End
  Else
  If Byte0<Byte1 Then
  Begin
    Byte2:=Byte1-Byte0;
    ChangeRecSize(Name,Byte2);
    Move(Mem[RecSel[I]:Word0+Byte0],
    Mem[RecSel[I]:Word0+Byte0+Byte2],RSize-(Word0+Byte0));
    For Word1:=IndexField+001 To PGXUpTo[I] Do
    Begin
      MoveMemToVec(I,Word1);
      With VecRec[I] Do Inc(RecOfs,Byte2);
      MoveVecToMem(I,Word1);
    End;
  End;
  Move(EditorField[001],Mem[RecSel[I]:Word0],Byte1);
  MoveEditorfieldToScreen(Name,IndexField);
  If EditorField<>EditorField2 Then PGXSave[I]:=BT;

End;




Procedure MoveEditorfieldToScreen(Name: ST08;IndexField: Word);
Label MOVE2;
Var
  I    : Byte;
  loop : Byte;

Begin

  I:=PGXIGet(Name);
  MoveMemToVec(I,indexfield);
  With vecrec[I] Do
  Begin
    If screen_fmode[I] Then
    For loop:=000 To lentab-001 Do
    Mem[screen_sel[I]:ofstab+loop*002]:=032
    Else
    For loop:=000 To lentab-001 Do
    Mem[screen_sel[I]:(ofstab-002)+loop*002]:=032;
    If Length(editorfield)=000 Then Exit;
    If Length(editorfield)>=lentab Then Goto MOVE2;
    If screen_fmode[I] Then
    Begin
      For loop:=000 To Length(editorfield)-001 Do
      Mem[screen_sel[I]:ofstab+loop*002]:=
      Ord(editorfield[loop+001]);
    End
    Else
    Begin
      For loop:=000 To Length(editorfield)-001 Do
      Mem[screen_sel[I]:ofstab+loop*002-002]:=
      Ord(editorfield[loop+001]);
    End;
    Exit;

    MOVE2:
    If screen_fmode[I] Then
    Begin
      For loop:=000 To lentab-001 Do
      Mem[screen_sel[I]:ofstab+loop*002]:=
      Ord(editorfield[loop+001]);
    End
    Else
    Begin
      For loop:=000 To lentab-001 Do
      Mem[screen_sel[I]:ofstab+loop*002-002]:=
      Ord(editorfield[loop+001]);
    End;
  End;

End;




Procedure MoveRecToEditorfield(Name: ST08;IndexField: Word);
Var
  Byte0 : Byte;
  I     : Byte;
  Stri0 : ST80;
  Word0 : Word;

Begin

  I:=PGXIGet(Name);
  If IndexField<=PGXUpTo[I] Then
  Begin
    MoveMemToVec(I,IndexField);
    With VecRec[I] Do Word0:=RecOfs;
    Byte0:=000;
    While Mem[RecSel[I]:Word0+Byte0]<>013 Do Inc(Byte0);
    EditorField[000]:=Chr(Byte0);
    Move(Mem[RecSel[I]:Word0],EditorField[001],Byte0);
    EditorField2:=EditorField;
  End
  Else
  Begin
    Str(IndexField,Stri0);
    ErrorOut('MoveRecToEditorfield: Name: '+
    Name+' INDEXFIELD zu hoch: '+Stri0,001,'',#000);
  End;

End;




Procedure MoveRecToFile(NameS: ST08;Var MFileD,MFileI: Hand);
Var
  I : Byte;

Begin

  I:=PGXIGet(NameS);
  BlockWrite(MFileD,Mem[RecSel[I]:0],RecSize[I],CntrHROW0);
  BlockWrite(MFileI,RecSize[I],001,CntrHROW0);

End;




Procedure MoveRecToRec(NameS,NameT: ST08);
{!!! Geht nur bei gleichartigen Dateien !!!}
Var
  IS    : Byte;
  IT    : Byte;
  Word0 : Word;
  Word1 : Word;

Begin

  IS:=PGXIGet(NameS);
  IT:=PGXIGet(NameT);
  Word0:=RecSize[IS];
  Word1:=RecSize[IT];
  If Word0>Word1 Then
  Begin
    Word0:=Word0-Word1;
    ChangeRecSize(NameT,Word0);
  End;
  Move(Mem[RecSel[IS]:0],Mem[RecSel[IT]:0],RecSize[IS]);
  Move(Mem[VecSel[IS]:0],Mem[VecSel[IT]:0],(PGXUpto[IS]+001)*016);
  RecSize[IT]:=RecSize[IS];

End;




Procedure MoveRecToScreen(Name: ST08);
Var
  Byte1 : Byte;
  Byte2 : Byte;
  I     : Byte;
  Word1 : Word;

Begin

  I:=PGXIGet(Name);
  If Screen_FMode[I] Then
  Begin
    For Word1:=000 To PGXUpTo[I] Do
    Begin
      MoveMemToVec(I,Word1);
      With VecRec[I] Do
      Begin
        Byte1:=000;
        While (Mem[RecSel[I]:RecOfs+Byte1]<>013)
        And (Byte1<LenTab) Do
        Begin
          Mem[Screen_Sel[I]:OfsTab+Byte1*002]:=
          Mem[RecSel[I]:RecOfs+Byte1];
          Inc(Byte1);
        End;
        For Byte2:=Byte1 To LenTab-001 Do
        Mem[Screen_Sel[I]:OfsTab+Byte2*002]:=032;
      End;
    End;
  End
  Else
  Begin
    For Word1:=000 To PGXUpTo[I] Do
    Begin
      MoveMemToVec(I,Word1);
      With VecRec[I] Do
      Begin
        Byte1:=000;
        While (Mem[RecSel[I]:RecOfs+Byte1]<>013)
        And (Byte1<LenTab) Do
        Begin
          Mem[Screen_Sel[I]:OfsTab+Byte1*002-002]:=
          Mem[RecSel[I]:RecOfs+Byte1];
          Inc(Byte1);
        End;
        For Byte2:=Byte1 To LenTab-001 Do
        Mem[Screen_Sel[I]:OfsTab+Byte2*002-002]:=032;
      End;
    End;
  End;

End;




Function  MoveScreenToTXT(Name: ST08;XP,YP,XW: Word;BBuendig: Bool): STFF;
Var
  I     : Byte;
  Stri0 : STFF;
  Word0 : Word;

Begin

  I:=PGXIGet(Name);
  If XW<Screen_Width[I] Then
  Begin
    Stri0[000]:=Chr(XW);
    For Word0:=XP To XP+XW-001 Do
    Stri0[Word0-XP+001]:=Chr(Mem[Screen_Sel[I]:
    YP*002*Screen_Width[I]+Word0*002]);
    If BBuendig Then
    MoveScreenToTXT:=BuendigLR(Stri0)
    Else
    MoveScreenToTXT:=Stri0;
  End
  Else
  ErrorOut('MoveScreenToTXT: Zu groe Differenz',001,'',#000);

End;




Procedure MoveTxtToScreen(Name: ST08;XPos,YPos: Word;TTXT: STFF);
Var
  Byte0 : Byte;
  I     : Byte;
  Word0 : Word;

Begin

  I:=PGXIGet(Name);
  For Byte0:=001 To Length(TTXT) Do
  Mem[Screen_Sel[I]:YPos*002*Screen_Width[I]+
  XPos*002+(Byte0-001)*002]:=Ord(TTXT[Byte0]);

End;




Procedure PageMask(Name: ST08;ByteH,ByteV: Byte);
Var
  Byte1 : Byte;
  I     : Byte;
  Word1 : Word;

Begin

  I:=PGXIGet(Name);
  screen_yend[I]:=Ord(ScreenMode[I])*025+024;
  If (ByteH=000) And (ByteV=000) Then
  Begin
    center_h[I]:=080-screen_width[I];
    center_h[I]:=(center_h[I] div 002)*002;
    center_v[I]:=screen_yend[I]-screen_height[I];
    center_v[I]:=center_v[I] div 002;
    If center_h[I]<000 then center_h[I]:=000;
    If center_v[I]<000 then center_v[I]:=000;
    If (screen_height[I]<screen_yend[I])
    Or (screen_width[I]<080) Then
    Patterns(Name,008*256+219);
  End
  Else
  Begin
    center_h[I]:=ByteH*002;
    center_v[I]:=ByteV;
  End;
  ShadowPGX(Name);
  If screen_width[I]>=080 then width[I]:=160
  Else width[I]:=screen_width[I]*002;
  Word1:=$0000;
  For Byte1:=000 To screen_height[I]-001 Do
  Begin
    Move(Mem[screen_sel[I]:Word1],
    Mem[SegB800:center_v[I]*160+
    center_h[I]+Byte1*160],width[I]);
    Word1:=Word1+screen_width[I]*002;
  End;
  CrsrOff;

End;




Procedure PageMask2(Name: ST08;IField: Word);
Const
  BBEnd : Bool=BT;

Var
  Byte0 : Byte;
  I     : Byte;
  Word0 : Word;
  Word1 : Word;
  Word2 : Word;

Begin

  I:=PGXIGet(Name);
  MoveMemToVec(I,IField);
  With VecRec[I] Do
  Begin
    Word0:=Ord(Is50)*4000+$0FA0;
    Word1:=Edge_Y*Screen_Width[I]*002;
    Inc(Word1,Edge_X*002);
    For Byte0:=000 To Screen_Height[I]-001 Do
    Begin
      Word2:=Center_V[I]*160+Center_H[I]+Byte0*160;
      If Word2<Word0 Then
      Begin
        Move(Mem[Screen_Sel[I]:Word1],Mem[SegB800:Word2],Width[I]);
        Inc(Word1,Screen_Width[I]*002);
      End
      Else
      Exit;
    End;
  End;

End;




Procedure Patterns(Name: ST08;ColChar: Word);
Var
  I : Byte;

Begin

  SetGround('',BF);
  I:=PGXIGet(Name);
  If Screen_Mode[I]=001 Then
  Move(Mem[SegB800:0],Mem[SegB800:4000],4000);

End;




Procedure PGXEdit(Name: ST08;MskName: ST08;
          NameRec: ST79;IdxStr: ST79;
          Byte_H,Byte_V: Byte;
          Bool13Ex: Bool;IndexF: IntM;
          BoolFree: Bool;BoolClr: Bool);
Begin

  EPGXEdit(Name,MskName,NameRec,IdxStr,
  Byte_H,Byte_V,Bool13Ex,IndexF,BoolFree,BoolClr);

End;




Procedure PGXFree(Name: ST08);
Var
  I     : Byte;
  Stri0 : ST02;
  Word0 : Word;

Begin

  I:=PGXIGet(Name);
  PGXBFix[I]:=BF;
  FreeBuf(RecSel[I],Word0);
  MemErrorOut('PGXFree '+Name,Word0,000);
  FreeBuf(Screen_Sel[I],Word0);
  MemErrorOut('PGXFree '+Name,Word0,000);
  FreeBuf(VecSel[I],Word0);
  MemErrorOut('PGXFree '+Name,Word0,000);
  If PGXPressFS[I]>000 Then
  Begin
    FreeBuf(PGXPressFS[I],Word0);
    MemErrorOut('PGXFree '+Name,Word0,000);
  End;
  Str(I:002,Stri0);
  Stri0:=FillString(Stri0,#032,#048);
  NamLst[I]:=Stri0+'--FREI';
  If PGXDPath[I]<>'' Then
  Begin
    If BooleanMove[I] Then
    OFileF(PGXIHandle[I],'',FClose,002);
    OFileF(PGXDHandle[I],'',FClose,001);
  End;
  MskNames[I]:='';
  RecSize[I]:=000;

End;




Function  PGXIGet(Name: ST08): Byte;
Var
  I : Byte;

Begin

  For I:=000 to PGX Do
  If Name=NamLst[I] Then
  Begin
    PGXIGet:=I;
    Exit;
  End;
  ErrorOut('PGXIGet: Name nicht gefunden - '+Name,001,'',#000);

End;




Procedure PGXIni;
Var
  Byte0 : Byte;

Begin

  For Byte0:=000 To PGX Do
  Begin
    RecSel[Byte0]:=000;
    MskNames[Byte0]:='';
    RecSize[Byte0]:=000;
    Screen_Sel[Byte0]:=000;
  End;

End;




Procedure PGXLoad(Name: ST08;MskName: ST08;
          NameRec: ST79;IdxStr: ST79;IndexF: IntM;FMode: Byte);
Begin

  EPGXLoad(Name,MskName,NameRec,IdxStr,IndexF,FMode);

End;




Procedure PGXPress(Name: ST08;Index: IntM);
Begin

  EPGXPress(Name,Index);

End;




Function  PGXSearch(Name: ST08;FNum: IntM;SStr: ST80): IntL;
Var
  I     : Byte;
  Long0 : IntL;
  SHWB0 : Bool;
  SHWH0 : Hand;

Begin

  TempI;
  SHWB0:=BT;
  PGXSearch:=-001;
  I:=PGXIGet(Name);
  For Long0:=000 To LastRec(Name) Do
  Begin
    ShowP('Suche ...',
    SHWB0,SHWH0,020,030,007,Long0,LastRec(Name),BF);
    RecVorF(Name,Long0);
    If SStr=GetFieldStr(Name,FNum,000) Then
    Begin
      LoadRec(Name,BT);
      PGXSearch:=Long0;
      ShowPClr(SHWH0);
      TempO;
      Exit;
    End;
  End;
  TempO;

End;




Function  PGXSearchJ(Name: ST08;FNum: IntM;SStr: ST80): IntL;
Var
  BEnd  : Bool;
  BTog1 : Bool;
  BTog2 : Bool;
  I     : Byte;
  JCntr : IntL;
  Long0 : IntL;
  Long1 : IntL;
  Stri0 : ST80;
  Str11 : ST80;
  Str12 : ST80;
  Str21 : ST80;
  Str22 : ST80;

Begin

  BEnd:=BF;
  BTog1:=BF;
  BTog2:=BF;
  Str11:='';
  Str12:='';
  Str21:='';
  Str22:='';
  JCntr:=000;
  I:=PGXIGet(Name);
  PGXSearchJ:=-001;
  Long0:=LastRec(Name);
  Long0:=Long0 Div 002;
  Long1:=Long0;
  Repeat
    Inc(JCntr);
    RecVorF(Name,Long1);
    If Long0 Div 002>000 Then Long0:=Long0 Div 002;
    Stri0:=GetFieldStr(Name,FNum,000);
    If SStr=Stri0 Then
    Begin
      BEnd:=BT;
      PGXSearchJ:=Long1;
    End
    Else
    If CheckBefore(SStr,Stri0) Then
    Begin
      Dec(Long1,Long0);
      If Long0=001 Then
      Begin
        If Not BTog1 Then
        Begin
          BTog1:=BT;
          RecVorF(Name,Long1);
          Str11:=GetFieldStr(Name,FNum,000);
        End
        Else
        Begin
          BTog1:=BF;
          RecVorF(Name,Long1);
          Str12:=GetFieldStr(Name,FNum,000);
        End;
        If  (Str11=Str12)
        And (Str21=Str22) Then
        Begin
          BEnd:=BT;
        End;
      End;
    End
    Else
    Begin
      Inc(Long1,Long0);
      If Long0=001 Then
      Begin
        If Not BTog2 Then
        Begin
          BTog2:=BT;
          RecVorF(Name,Long1);
          Str21:=GetFieldStr(Name,FNum,000);
        End
        Else
        Begin
          BTog2:=BF;
          RecVorF(Name,Long1);
          Str22:=GetFieldStr(Name,FNum,000);
        End;
      End;
    End;
  Until BEnd;

End;




Procedure PGXShow;
Label LOOP2,
      LOOP3,
      LOOPC,
      LOOPD,
      LOOPU,
      LOOPX;
Var
  FName : ST13;
  From  : Byte;
  HIndx : Byte;
  UpTo  : Byte;

Procedure ClrLine;
Var
  Byte0 : Byte;
Begin
  For Byte0:=From To UpTo Do
  Mem[SegB800:006*160+HIndx*160+Byte0*002+001]:=112;
End;

Procedure HShow;
Var
  Byte0 : Byte;
  Stri0 : ST80;
  Stri1 : ST80;
  Stri2 : ST80;
Begin
  For Byte0:=000 To PGX Do
  Begin
    Str(Byte0:003,Stri0);
    Stri0:=FillString(Stri0,#032,#048);
    Str(RecSize[Byte0]:005,Stri1);
    Stri2:='HNum.:'+Stri0+
    ' PGX-Name:'+BuendigL2(008,NamLst[Byte0])+
    ' Maskenname:'+BuendigL2(008,MskNames[Byte0])+
    ' Seg:'+
    GetHexToStr(Hi(RecSel[Byte0]))+
    GetHexToStr(Lo(RecSel[Byte0]))+
    ' RecSize:'+Stri1;
    WriteVR(Stri2,003,Byte0+(025+Ord(Is50)*025-(014-002)) Div 002);
  End;
  For Byte0:=From To UpTo Do
  Mem[SegB800:006*160+HIndx*160+Byte0*002+001]:=015;
End;

Begin

  From:=002;
  UpTo:=075;
  HIndx:=000;
  ScreenParams(BT);
  SetScreenMode(000,007);
  SetGround('',BT);
  OptTableau3(000,000,074,014,'',BT);

  LOOP2:
  HShow;

  LOOP3:
  Wait;
  ClrLine;
  If Boolean13 Then Goto LOOPC;
  If BooleanDn Then Goto LOOPD;
  If BooleanUp Then Goto LOOPU;
  If BooleanEx Then Goto LOOPX;
  Goto LOOP3;

  LOOPC:
  Click;
  Goto LOOP2;

  LOOPD:
  Inc(HIndx);
  If HIndx>PGX Then HIndx:=000;
  Goto LOOP2;

  LOOPU:
  Dec(HIndx);
  If HIndx=255 Then HIndx:=PGX;
  Goto LOOP2;

  LOOPX:
  ScreenParams(BF);

End;




Function  PGXStr(Name: ST08): ST01;
Begin

  PGXIGet(Name);
  Str(PGXI,Name);
  PGXStr:=Name;

End;




Function  PGXTest(Name: ST08): Bool;
Var
  Byte0 : Byte;

Begin

  PGXTest:=BT;
  BooleanErr:=BF;
  For Byte0:=000 to PGX Do
  If Name=NamLst[Byte0] Then Exit;
  BooleanErr:=BT;
  PGXTest:=BF;

End;




Procedure RecAnf(NameS,NameT: ST08);
Var
  IS    : Byte;
  IT    : Byte;
  Index : Word;

Begin

  IS:=PGXIGet(NameS);
  IT:=PGXIGet(NameT);
  RecVorT(NameT,LastRec(NameT));
  RecVor1(NameT);
  For Index:=000 To PGXUpTo[IT] Do
  Begin
    MoveMemToVec(IT,Index);
    With VecRec[IT] Do
    FillField(NameT,Index,GetFieldStr(NameS,Index,FMode));
  End;
  SaveRec(NameT,BT);

End;




Procedure RecDel(Name: ST08;BAsk: Bool);
Var
  I     : Byte;
  Long1 : IntL;
  Long2 : IntL;
  Long3 : IntL;
  Long4 : IntL;
  Word1 : Word;
  Word4 : Word;

Begin

  I:=PGXIGet(Name);
  If Not PGXBFix[I] Then
  If LastRec(Name)>000 Then
  Begin
    SaveRec(Name,BT);
    If BAsk Then
    Begin
      OptionsR(022,005,
      'Diesen Datensatz unwideruflich l'+
      'schen ?','~Ja~FeldE~xit','J',BT);
      If BooleanEx Or (Char0='F') Then Exit;
    End;
    BooleanKey:=BT;
    If LastRec(Name)=IndexRecI[I] Then
    Begin
      Seek(PGXDHandle[I],IndexRecD[I]);
      Seek(PGXIHandle[I],IndexRecI[I]-001);
      BlockRead(PGXIHandle[I],Word1,001,CntrHROW0);
      Seek(PGXIHandle[I],IndexRecI[I]);
      Dec(IndexRecI[I]);
      Dec(IndexRecD[I],Word1);
    End
    Else
    Begin
      Long1:=IndexRecI[I];
      Long2:=IndexRecD[I];
      Long3:=LastRec(Name);
      Long4:=IndexRecD[I]+RecSize[I];
      Repeat
        Seek(PGXIHandle[I],Long1+001);
        BlockRead(PGXIHandle[I],Word4,001,CntrHROW0);
        Seek(PGXIHandle[I],Long1);
        BlockWrite(PGXIHandle[I],Word4,001,CntrHROW0);
        If Word4>RecSize[I] Then
        ChangeRecSize(Name,Word4-RecSize[I])
        Else
        If RecSize[I]>Word4 Then
        ChangeRecSize(Name,(RecSize[I]-Word4)*-001);
        Seek(PGXDHandle[I],Long4);
        BlockRead(PGXDHandle[I],Mem[RecSel[I]:0],Word4,CntrHROW0);
        Long4:=FilePos(PGXDHandle[I]);
        Seek(PGXDHandle[I],Long2);
        BlockWrite(PGXDHandle[I],Mem[RecSel[I]:0],Word4,CntrHROW0);
        Long2:=FilePos(PGXDHandle[I]);
        Inc(Long1);
      Until Long1=Long3;
      Seek(PGXDHandle[I],Long2);
      Seek(PGXIHandle[I],Long1);
    End;
    Truncate(PGXDHandle[I]);
    Truncate(PGXIHandle[I]);
    LoadRec(Name,BT);
  End;

End;




Procedure RecIns(Name: ST08;BAsk: Bool);
Var
  I     : Byte;
  Long0 : IntL;
  Long1 : IntL;
  LongD : IntL;
  LongI : IntL;
  Stri0 : ST80;
  Stri1 : ST80;
  Stri2 : ST80;
  Word1 : Word;
  Word2 : Word;
  Word3 : Word;

Begin

  I:=PGXIGet(Name);
  If Not PGXBFix[I] Then
  Begin
    LongD:=IndexRecD[I];
    LongI:=IndexRecI[I];
    If LastRec(Name)<IndexRecI[I] Then
    Begin
      Dec(IndexRecI[I]);
      Seek(PGXIHandle[I],IndexRecI[I]);
      BlockRead(PGXIHandle[I],Word1,001,CntrHROW0);
      Dec(IndexRecD[I],Word1);
    End;
    SaveRec(Name,BT);
    IndexRecD[I]:=LongD;
    IndexRecI[I]:=LongI;
    If BAsk Then
    Begin
      If LastRec(Name)<IndexRecI[I] Then
      Begin
        Stri0:='anfgen';
        Stri1:='';
      End
      Else
      Begin
        Stri0:='einfgen';
        Stri1:='~Feld';
      End;
      OptionsR(022,005,'Neuen Datensatz '+Stri0+' ?',
      '~Ja'+Stri1+'E~xit','J',BT);
      If BooleanEx Or (Char0='F') Then Exit;
    End;
    BooleanKey:=BT;
    Word1:=(PGXUpTo[I]+001)*002;
    If LastRec(Name)<IndexRecI[I] Then
    Begin
      Seek(PGXDHandle[I],IndexRecD[I]);
      Seek(PGXIHandle[I],IndexRecI[I]);
      Word2:=$0A0D;
      For Word3:=000 To PGXUpTo[I] Do
      BlockWrite(PGXDHandle[I],Word2,002,CntrHROW0);
      BlockWrite(PGXIHandle[I],Word1,001,CntrHROW0);
    End
    Else
    Begin
      Long0:=LastRec(Name);
      Long1:=FileSize(PGXDHandle[I]);
      Repeat
        Seek(PGXIHandle[I],Long0);
        BlockRead(PGXIHandle[I],Word3,001,CntrHROW0);
        If Word3>RecSize[I] Then
        ChangeRecSize(Name,Word3-RecSize[I])
        Else
        If RecSize[I]>Word3 Then
        ChangeRecSize(Name,(RecSize[I]-Word3)*-001);
        Seek(PGXIHandle[I],Long0+001);
        BlockWrite(PGXIHandle[I],Word3,001,CntrHROW0);
        Seek(PGXDHandle[I],Long1-Word3);
        BlockRead(PGXDHandle[I],Mem[RecSel[I]:0],Word3,CntrHROW0);
        Seek(PGXDHandle[I],Long1-Word3+Word1);
        BlockWrite(PGXDHandle[I],Mem[RecSel[I]:0],Word3,CntrHROW0);
        Dec(Long0);
        Dec(Long1,Word3);
      Until Long0<IndexReci[I];
      Seek(PGXDHandle[I],IndexRecD[I]);
      Seek(PGXIHandle[I],IndexRecI[I]);
      Word2:=$0A0D;
      For Word3:=000 To PGXUpTo[I] Do
      BlockWrite(PGXDHandle[I],Word2,002,CntrHROW0);
      BlockWrite(PGXIHandle[I],Word1,001,CntrHROW0);
    End;
    LoadRec(Name,BT);
  End;

End;




Procedure RecVor(Name: ST08);
Var
  I : Byte;

Begin

  I:=PGXIGet(Name);
  SaveRec(Name,BF);
  If IndexRecI[I]<=LastRec(Name) Then
  Begin
    Inc(IndexRecD[I],RecSize[I]);
    Inc(IndexRecI[I]);
    If IndexRecI[I]>LastRec(Name) Then
    Begin
      RecIns(Name,BT);
      If BooleanEx Then
      Begin
        Dec(IndexRecD[I],RecSize[I]);
        Dec(IndexRecI[I]);
      End;
    End
    Else
    LoadRec(Name,BT);
  End;

End;




Procedure RecVor1(Name: ST08);
Var
  I : Byte;

Begin

  I:=PGXIGet(Name);
  If Not PGXBFix[I] Then
  Begin
    SaveRec(Name,BT);
    Inc(IndexRecI[I]);
    Inc(IndexRecD[I],RecSize[I]);
    If IndexRecI[I]>LastRec(Name) Then RecIns(Name,BF);
    LoadRec(Name,BT);
  End;

End;




Procedure RecVorF(Name: ST08;Upto: IntL);
Begin

  RecVorX(Name,UpTo);
  LoadRec(Name,BF);

End;




Procedure RecVorT(Name: ST08;Upto: IntL);
Begin

  RecVorX(Name,UpTo);
  LoadRec(Name,BT);

End;




Procedure RecVorX(Name: ST08;Upto: IntL);
Var
  ArrLen  : Array[000..999] Of Word;
  I       : Byte;
  Long0   : IntL;
  Word0   : Word;
  Word1   : Word;
  Word2   : Word;

Begin

  I:=PGXIGet(Name);
  If IndexRecI[I]<>UpTo Then
  Begin
    Seek(PGXDHandle[I],IndexRecD[I]);
    Seek(PGXIHandle[I],IndexRecI[I]);
    If IndexRecI[I]<UpTo Then
    Begin
      While IndexRecI[I]<UpTo Do
      Begin
        Word0:=UpTo-IndexRecI[I];
        If Word0>SizeOf(ArrLen) Div 002 Then
        Word0:=SizeOf(ArrLen) Div 002;
        BlockRead(PGXIHandle[I],ArrLen,Word0,Word1);
        Long0:=000;
        For Word2:=000 To Word1-001 Do
        Inc(Long0,ArrLen[Word2]);
        Inc(IndexRecD[I],Long0);
        Inc(IndexRecI[I],Word1);
        If Word0<>Word1 Then
        UpTo:=IndexRecI[I];
      End;
    End
    Else
    While IndexRecI[I]>UpTo Do
    Begin
      Word0:=IndexRecI[I]-UpTo;
      if Word0>SizeOf(ArrLen) Div 002 Then
      Word0:=SizeOf(ArrLen) Div 002;
      Seek(PGXIHandle[I],IndexRecI[I]-Word0);
      BlockRead(PGXIHandle[I],ArrLen,Word0,Word1);
      Long0:=000;
      For Word2:=000 To Word1-001 Do
      Inc(Long0,ArrLen[Word2]);
      Dec(IndexRecD[I],Long0);
      Dec(IndexRecI[I],Word1);
    End;
  End;

End;




Procedure RecZur(Name: ST08);
Var
  I     : Byte;
  Word1 : Word;

Begin

  I:=PGXIGet(Name);
  SaveRec(Name,BF);
  If IndexRecI[I]>000 Then
  Begin
    Dec(IndexRecI[I]);
    Seek(PGXIHandle[I],IndexRecI[I]);
    BlockRead(PGXIHandle[I],Word1,001,CntrHROW0);
    Dec(IndexRecD[I],Word1);
    LoadRec(Name,BT);
  End
  Else
  Click;

End;




Procedure SaveRec(Name: ST08;BSave: Bool);
Var
  I : Byte;

Begin

  I:=PGXIGet(Name);
  If PGXDPath[I]<>'' Then
  Begin
    If BooleanMove[I] Then
    Begin
      If PGXSave[I] Or BSave Then
      SaveRecMove(Name);
      PGXSave[I]:=BF;
    End
    Else
    If PGXSave[I] Or BSave Then
    Begin
      Seek(PGXDHandle[I],000);
      BlockWrite(PGXDHandle[I],Mem[RecSel[I]:0],RecSize[I],CntrHROW0);
      Truncate(PGXDHandle[I]);
    End;
  End;

End;




Procedure SaveRecMove(Name: ST08);
Var
  BSeg       : Word;
  BSize      : Word;
  ECode      : Word;
  I          : Byte;
  Long0      : IntL;
  Long1      : IntL;
  Long2      : IntL;
  Word1      : Word;
  Word2      : Word;
  Word3      : Word;

Begin

  I:=PGXIGet(Name);
  BSize:=8192;
  Repeat
    BSeg:=GetBuf(BSize,ECode,BSize);
    BSize:=BSize*016;
  Until Not BooleanErr Or (ECode=007);
  MemErrorOut('SaveRecMove ('+Name+') GetBuf',ECode,000);
  Seek(PGXIHandle[I],IndexRecI[I]);
  BlockRead(PGXIHandle[I],Word1,001,CntrHROW0);
  If Word1>RecSize[I] Then
  Begin
    Word3:=Word1-RecSize[I];
    Seek(PGXDHandle[I],IndexRecD[I]+Word1);
    Long0:=FilePos(PGXDHandle[I]);
    Long1:=Long0-Word3;
    Repeat
      Seek(PGXDHandle[I],Long0);
      BlockRead(PGXDHandle[I],Mem[BSeg:0],BSize,Word2);
      Long0:=FilePos(PGXDHandle[I]);
      Seek(PGXDHandle[I],Long1);
      BlockWrite(PGXDHandle[I],Mem[BSeg:0],Word2,CntrHROW0);
      Long1:=FilePos(PGXDHandle[I]);
    Until Word2<BSize;
    Truncate(PGXDHandle[I]);
  End
  Else
  If Word1<RecSize[I] Then
  Begin
    Word3:=RecSize[I]-Word1;
    Long0:=FileSize(PGXDHandle[I])-BSize;
    If Long0<IndexRecD[I] Then Long0:=IndexRecD[I];
    Repeat
      Long1:=Long0;
      Seek(PGXDHandle[I],Long0);
      BlockRead(PGXDHandle[I],Mem[BSeg:0],BSize,Word2);
      Seek(PGXDHandle[I],Long0+Word3);
      BlockWrite(PGXDHandle[I],Mem[BSeg:0],Word2,CntrHROW0);
      Dec(Long0,CntrHROW0);
    Until Long0<=IndexRecD[I];
    Word2:=Long1-IndexRecD[I];
    Seek(PGXDHandle[I],IndexRecD[I]);
    BlockRead(PGXDHandle[I],Mem[BSeg:0],Word2,CntrHROW0);
    Seek(PGXDHandle[I],IndexRecD[I]+Word3);
    BlockWrite(PGXDHandle[I],Mem[BSeg:0],Word2,CntrHROW0);
  End;
  Seek(PGXDHandle[I],IndexRecD[I]);
  BlockWrite(PGXDHandle[I],Mem[RecSel[I]:0],RecSize[I],CntrHROW0);
  Seek(PGXIHandle[I],IndexRecI[I]);
  BlockWrite(PGXIHandle[I],RecSize[I],001,CntrHROW0);
  FreeBuf(BSeg,ECode);
  MemErrorOut('SaveRecMove ('+Name+') FreeBuf',ECode,000);

End;




Function  SearchRec(Name: ST08;I0,I1,I2,I3,I4: IntM;
          T0,T1,T2,T3,T4: ST80;LongI: IntL;BAll: Bool): IntL;

Var
  BErr  : Bool;
  I     : Byte;
  Long0 : IntL;
  Long1 : IntL;
  LongL : IntL;
  LongT : IntL;
  SHWB0 : Bool;
  SHWH0 : Hand;

Begin

  TempI;
  I:=PGXI;
  SHWB0:=BT;
  Long0:=000;
  LongL:=LastRec(Name);
  If PGXOMod[I]<>FRead Then SaveRec(Name,BT);
  For Long1:=000 to LongL Do
  Begin
    ShowP('SearchRec',SHWB0,SHWH0,020,002,016,Long1,LongL,BF);
    SearchRec2(Name,I0,I1,I2,I3,I4,T0,T1,T2,T3,T4,Long1,BErr);
    If Not BErr Then
    Begin
      If BAll Then
      Begin
        If LongI<>Long1 Then Inc(Long0);
      End
      Else
      If LongI<>Long1 Then
      Begin
        SearchRec:=Long1;
        ShowPClr(SHWH0);
        BooleanErr:=BF;
        PGXI:=I;
        TempO;
        Exit;
      End;
    End;
  End;
  If Long0>000 Then
  Begin
    SearchRec:=Long0;
    BooleanErr:=BF;
  End
  Else
  BooleanErr:=BT;
  PGXI:=I;
  TempO;

End;




Procedure SearchRec2(Name: ST08;I0,I1,I2,I3,I4: IntM;
          T0,T1,T2,T3,T4: ST80;LongX: IntL;Var BErr: Bool);
Begin

  BErr:=BF;
  RecVorF(Name,LongX);
  If I0>-001 Then
  Begin
    If T0<>GetFieldStr(Name,I0,000) Then BErr:=BT;
    If I1>-001 Then
    Begin
      If T1<>GetFieldStr(Name,I1,000) Then BErr:=BT;
      If I2>-001 Then
      Begin
        If T2<>GetFieldStr(Name,I2,000) Then BErr:=BT;
        If I3>-001 Then
        Begin
          If T3<>GetFieldStr(Name,I3,000) Then BErr:=BT;
          If I4>-001 Then
          Begin
            If T4<>GetFieldStr(Name,I4,000) Then BErr:=BT;
            If Not BErr Then Exit;
          End
          Else
          If Not BErr Then Exit;
        End
        Else
        If Not BErr Then Exit;
      End
      Else
      If Not BErr Then Exit;
    End
    Else
    If Not BErr Then Exit;
  End
  Else ErrorOut('SearchRec: kein String zum Suchen ?',001,'',#000);

End;




Procedure ShadowPGX(Name: ST08);
Var
  Byte0 : Byte;
  Byte1 : Byte;
  I     : Byte;

Begin

  I:=PGXIGet(Name);
  For Byte0:=Center_V[I]+001
  To Screen_Height[I]+Center_V[I]-001 Do
  For Byte1:=000 To 001 Do
  Mem[SegB800:Byte0*160+Center_H[I]+
  (Screen_Width[I]+Byte1)*002+001]:=008;
  For Byte1:=Center_H[I] Div 002+002
  To Screen_Width[I]+Center_H[I] Div 002+001 Do
  Mem[SegB800:(Byte0+001)*160+Byte1*002+001]:=008;

End;




Procedure TempIn(Name: ST08);
Var
  I     : Byte;
  Word0 : Word;
  Word1 : Word;

Begin

  I:=PGXIGet(Name);
  ScreenSeg[I]:=GetBuf(4000+Ord(Is50)*4000,Word0,Word1);
  MemErrorOut('PGXTempIn',Word0,000);
  Move(Mem[SegB800:000],Mem[ScreenSeg[I]:000],4000+Ord(Is50)*4000);
  FlagScrBuf[I]:=Ord(Is50);

End;




Procedure TempOut(Name: ST08);
Var
  I     : Byte;
  Word0 : Word;

Begin

  I:=PGXIGet(Name);
  If Screen_Mode[I]<>FlagScrBuf[I] Then
  SetScreenMode(FlagScrBuf[I],000);
  Move(Mem[ScreenSeg[I]:000],Mem[SegB800:000],4000+Ord(Is50)*4000);
  FlagScrBuf[I]:=255;
  FreeBuf(ScreenSeg[I],Word0);
  MemErrorOut('PGXTempOut',Word0,000);

End;




Procedure WriteIndexRec(Name: ST08);
Begin

  EWriteIndexRec(Name);

End;




Procedure WriteVRam(Name: ST08;VStr: STFF;VMod: Bool);
Begin

  EWriteVRam(Name,VStr,VMod);

End;


Begin

  PGXIni;

END.
