Unit SWCXMS;

{$F+}

Interface


Uses CRT,
     DOS,
     Graph,
     SWCMask,
     SWCMouse,
     SWCVaria;



Procedure XMSCallFunc(Handle: Byte;Func: XMSFunc);
Procedure XMSChange(Name: ST12;ChngSize: IntL);
Procedure XMSChkDriver;
Procedure XMSErrorOut(ProcNam: ST80;ErrNum: Word;ErrNot: Word);
Procedure XMSFree(Name: ST12);
Procedure XMSFreeByHandle(XMSH: Hand);
Function  XMSGetFree: IntL;
Function  XMSGetHandle(Name: ST12;Size: IntL): IntM;
Function  XMSGetLast: IntM;
Function  XMSGHand2(HNum: Byte): Byte;
Function  XMSTest(Name: ST12): Bool;



Implementation



Uses SWCDIR,
     SWCFNB,
     SWCLSN,
     SWCMskIF,
     SWCMskPX,
     SWCOpt,
     SWCPGX,
     SWCSubE,
     SWCSubPr,
     SWCUtil;




Procedure XMSCallFunc(Handle: Byte;Func: XMSFunc);
Var
  BLen2  : IntL;
  BoolE  : Bool;
  Error  : Word;
  FlgTmp : Bool;
  Last   : Byte;
  MaxSiz : Word;
  Stri0  : ST80;
  Stri1  : ST80;
  TmpSeg : Word;
  XMS1BL : IntL;
  XMS1SH : Word;
  XMS1SO : IntL;
  XMS1TH : Word;
  XMS1TO : IntL;
  XMS2BL : IntL;
  XMS2SH : Word;
  XMS2SO : IntL;
  XMS2TH : Word;
  XMS2TO : IntL;

Procedure XMSCallFunc2; Assembler;
Asm
  Push  BP
  Push  DS
  Push  SP
  Push  SS
  Mov   AX,XMSREGAX
  Mov   BX,XMSREGBX
  Mov   CX,XMSREGDS
  Mov   SI,XMSREGSI
  Mov   DX,XMSREGDX
  Call  DS:[XMSADRESS]
  Pop   SS
  Pop   SP
  Pop   DS
  Pop   BP
  Mov   XMSREGAX,AX
  Mov   XMSREGBX,BX
  Mov   XMSREGDX,DX
  Cmp   AX,$0001
  jz    @NOERROR
  Mov   XMSERROR,BL
  Jmp   @XMSEXIT
  @NOERROR:
  Mov   XMSERROR,000
  @XMSEXIT:
End;

Procedure XMSErrorOutHlp;
Begin
  If XMSERROR>000 Then
  With XMSMOVSTRUC DO
  Begin
    Str(XMSLen,Stri0);
    Str(XMSGetFree,Stri1);
    XMSErrorOut('XMSCallFunc: '+
    XMSNAMES[Handle]+'  BL:'+Stri0+'  Frei:'+Stri1,XMSERROR,000);
  End;
End;

Procedure XMSCallFunc1;
Begin
  FlgTmp:=BF;
  With XMSMOVSTRUC Do
  Begin
    Case Func Of
    A20GlobOff : Begin
                   XMSREGAX:=$0400;
                 End;
    A20GlobOn  : Begin
                   XMSREGAX:=$0300;
                 End;
    AllocEMB   : Begin
                   XMSREGAX:=$0900;
                 End;
    FreeEMB    : Begin
                   XMSREGAX:=$0A00;
                   XMSREGDX:=XMSHANDLE;
                 End;
    FreeHMA    : Begin
                   XMSREGAX:=$0200;
                 End;
    GetHMA     : Begin
                   XMSREGAX:=$0100;
                   XMSREGDX:=$FFFF;
                 End;
    GetFree    : XMSREGAX:=$0800;
    GetVersion : XMSREGAX:=$0000;
    MoveEMB    : Begin
                   BLen2:=XMSLen;
                   If XMSLen<001 Then Exit;
                   If XMSLen And 001=001 Then
                   Begin
                     Inc(XMSLen);
                     If HandleT=000 Then
                     Begin
                       TmpSeg:=GetBuf(XMSLen,Error,MaxSiz);
                       MemErrorOut('XMSCallFunc',Error,000);
                       Move(OffsT,XMSOFS,004);
                       Ptr0:=Ptr(TmpSeg,000);
                       Move(Ptr0,OffsT,004);
                       FlgTmp:=BT;
                     End
                     Else
                     Begin
                       XMS1BL:=XMSLen;
                       XMS1SH:=HandleS;
                       XMS1SO:=OffsS;
                       XMS1TH:=HandleT;
                       XMS1TO:=OffsT;
                       XMSLen:=002;
                       HandleS:=XMSHANDLE;
                       HandleT:=XMSHANDLE;
                       OffsS:=XMS1TO+XMS1BL-001;
                       OffsT:=XMSFREELONG*1024-002;
                       XMS2BL:=002;
                       XMS2SH:=HandleS;
                       XMS2SO:=OffsS;
                       XMS2TH:=HandleT;
                       XMS2TO:=OffsT;
                       XMSCallFunc(Handle,MoveEMB);
                       XMSLen:=XMS1BL;
                       HandleS    :=XMS1SH;
                       OffsS      :=XMS1SO;
                       HandleT    :=XMS1TH;
                       OffsT      :=XMS1TO;
                       XMSCallFunc(Handle,MoveEMB);
                       XMSLen:=002;
                       HandleT    :=XMS2SH;
                       OffsT      :=XMS2SO;
                       HandleS    :=XMS2TH;
                       OffsS      :=XMS2TO;
                       XMSCallFunc(Handle,MoveEMB);
                       XMSLen:=BLen2;
                       Exit;
                     End;
                   End;
                   XMSREGAX:=$0B00;
                   XMSREGDS:=Seg(XMSMOVSTRUC);
                   XMSREGSI:=Ofs(XMSMOVSTRUC);
                 End;
    End;
    XMSCallFunc2;
    XMSErrorOutHlp;
    Case Func Of
    MoveEMB    : Begin
                   If FlgTmp Then
                   Begin
                     Move(Mem[TmpSeg:0],Mem[XMSSEG:XMSOFS],BLen2);
                     FreeBuf(TmpSeg,Error);
                     MemErrorOut('XMSCallFunc',Error,000);
                   End;
                   XMSLen:=BLen2;
                 End;
    End;
  End;
End;

Begin

  BoolE:=BooleanErr;
  XMSCallFunc1;
  BooleanErr:=BoolE;

End;




Procedure XMSChange(Name: ST12;ChngSize: IntL);
Var
  Byte0 : Byte;
  Byte1 : Byte;
  LastX : IntL;
  Long0 : IntL;

Begin

  LastX:=XMSGetLast;
  If LastX>-001 Then
  Begin
    For Byte0:=000 To XMS Do
    Begin
      If XMSNAMES[Byte0]=name Then
      If XMSBOOLS[Byte0]=true Then
      Begin
        If ChngSize<000 Then
        Begin
          For Byte1:=Byte0+001 To LastX Do
          With XMSMOVSTRUC Do
          Begin
            XMSLen:=XMSSIZES[Byte1];
            handles:=XMSHANDLE;
            offss:=XMSOFFSETS[Byte1];
            Dec(XMSOFFSETS[Byte1],Abs(ChngSize));
            handlet:=XMSHANDLE;
            offst:=XMSOFFSETS[Byte1];
            XMSCallFunc(Byte1,MoveEMB);
          End;
          Dec(XMSSIZES[Byte0],Abs(ChngSize));
          BooleanErr:=BF;
          Exit;
        End
        Else
        Begin
          If Byte0<LastX Then
          Begin
            With XMSMOVSTRUC Do
            Begin
              XMSLen:=XMSMyBlock*1024-
              (XMSGetFree+XMSOFFSETS[Byte0]+XMSSIZES[Byte0]);
              If XMSLen<XMSGetFree Then
              Begin
                Long0:=XMSLen;
                HandleS:=XMSHANDLE;
                HandleT:=XMSHANDLE;
                OffsS:=XMSOFFSETS[Byte0+001];
                OffsT:=XMSMyBlock*1024-XMSGetFree{+ChngSize};
                XMSCallFunc(Byte0,MoveEMB);
                XMSLen:=Long0;
                HandleS:=XMSHANDLE;
                HandleT:=XMSHANDLE;
                OffsS:=XMSMyBlock*1024-XMSGetFree{+ChngSize};
                OffsT:=XMSOFFSETS[Byte0+001]+ChngSize;
                XMSCallFunc(Byte0+001,MoveEMB);
              End
              Else
              Begin
                BooleanErr:=BT;
                Exit;
              End;
            End;
            For Byte1:=Byte0+001 To LastX Do
            Inc(XMSOFFSETS[Byte1],ChngSize);
          End;
          Inc(XMSSIZES[Byte0],ChngSize);
          BooleanErr:=BF;
          Exit;
        End;
      End
      Else
      ErrorOut('XMSChange: Name '+Name+' nicht in '+
      'BOOLscher Tabelle erfat oder gefunden',001,'',#000);
    End;
  End
  Else
  ErrorOut('XMSChange: Keine Belegung in '+
  'BOOLscher Tabelle erfat',001,'',#000);

End;




Procedure XMSChkDriver;
Var
  Byte0 : Byte;
  Regs0 : Regi;
  Stri0 : ST80;
  Stri1 : ST80;

Procedure HelpIni;
Var
  Byte0 : Byte;
Begin
  Str(XMSFREELONG:006,XMSFREESTR);
  XMSBISXMSDRV:=BT;
  For Byte0:=000 To XMS Do
  Begin
    XMSBOOLS[Byte0]:=BF;
    XMSNAMES[Byte0]:='';
    XMSSIZES[Byte0]:=000;
    XMSOFFSETS[Byte0]:=000;
    XMSHANDLES[Byte0]:=Byte0;
  End;
End;

Begin

  With Regs0 Do
  Begin
    AX:=$4300;
    Intr($2F,Regs0);
    If AL=$80 Then
    Begin
      AX:=$4310;
      Intr($2F,Regs0);
      XMSADRESS:=Ptr(ES,BX);
      XMSCallFunc(000,GetVersion);
      XMSCallFunc(000,GetVersion);
      If Hi(XMSREGAX)>=003 Then
      Begin
        XMSCallFunc(000,GetFree);
        XMSMyBlock:=XMSREGDX;
        XMSCallFunc(000,AllocEMB);
        XMSHANDLE:=XMSREGDX;
        XMSCallFunc(000,GetFree);
        XMSFREELONG:=XMSREGDX;
        HelpIni;
        Exit;
      End
      Else
      If Hi(XMSREGAX)=002 Then
      Begin
        XMSCallFunc(000,GetFree);
        XMSMyBlock:=XMSREGAX;
        XMSFREELONG:=XMSREGDX-XMSREGAX;
        XMSREGDX:=XMSREGAX;
        XMSCallFunc(000,AllocEMB);
        XMSHANDLE:=XMSREGDX;
        HelpIni;
        Exit;
      End
      Else
      ErrorOut('Versionsnummer XMS-Treiber < 2',001,'',#000);
    End;
  End;
  ErrorOut('XMS-Treiberadresse nicht gefunden',001,'',#000);

End;




Procedure XMSErrorOut(ProcNam: ST80;ErrNum: Word;ErrNot: Word);
Var
  Stri0 : ST80;

Begin

  If ErrNum>000 Then
  Begin
    If ErrNum<>ErrNot Then
    Begin
      Case ErrNum Of
      $80 : Stri0:='Unbekannte Funktion';
      $81 : Stri0:='VDISK-RAMDisk entdeckt';
      $82 : Stri0:='Fehler auf Adressleitung A20';
      $8E : Stri0:='Allgemeiner Treiberfehler';
      $8F : Stri0:='Nicht behebbarer Fehler';
      $90 : Stri0:='Keine HMA vorhanden';
      $91 : Stri0:='HMA bereits vergeben';
      $92 : Stri0:='DX < HMAMin';
      $93 : Stri0:='HMA nicht allokiert';
      $94 : Stri0:='Adressleitung A20 noch an';
      $A0 : Stri0:='Kein XMS-Speicher mehr frei';
      $A1 : Stri0:='Alle XMS-Handles belegt';
      $A2 : Stri0:='Ungltiger Handle';
      $A3 : Stri0:='Source-Handle ungltig';
      $A4 : Stri0:='Source-Offset ungltig';
      $A5 : Stri0:='Target-Handle ungltig';
      $A6 : Stri0:='Target-Offset ungltig';
      $A7 : Stri0:='Ungltige Lnge fr Moving';
      $A8 : Stri0:='Verbotene berlappung fr Moving';
      $A9 : Stri0:='Parittsfehler';
      $AA : Stri0:='UMB ist nicht gesperrt';
      $AB : Stri0:='UMB ist noch gesperrt';
      $AC : Stri0:='berlauf UMB-Sperrzhler';
      $AD : Stri0:='UMB kann nicht gesperrt werden';
      $B0 : Stri0:='Kleinerer UMB verfgbar';
      $B1 : Stri0:='Kein UMB mehr verfgbar';
      $B2 : Stri0:='UMB Segmentadresse ungltig';
      Else Exit;
      End;
      ErrorOut(ProcNam+':'+Stri0,001,'',#000);
    End;
  End;

End;




Procedure XMSFree(Name: ST12);
Var
  AddL  : IntL;
  Byte0 : Byte;
  Byte1 : Byte;
  HandT : Byte;
  LastX : IntL;

Begin

  LastX:=XMSGetLast;
  If LastX>-001 Then
  Begin
    For Byte0:=000 To XMS Do
    Begin
      If XMSNAMES[Byte0]=Name Then
      If XMSBOOLS[Byte0]=BT   Then
      Begin
        AddL:=XMSOFFSETS[Byte0];
        HandT:=XMSHANDLES[Byte0];
        For Byte1:=Byte0+001 To LastX Do
        Begin
          With XMSMOVSTRUC Do
          Begin
            XMSLen:=XMSSIZES[Byte1];
            handles:=XMSHANDLE;
            offss:=XMSOFFSETS[Byte1];
            handlet:=XMSHANDLE;
            offst:=AddL;
          End;
          XMSCallFunc(Byte1,MoveEMB);
          XMSOFFSETS[Byte1-001]:=AddL;
          XMSSIZES[Byte1-001]:=XMSSIZES[Byte1];
          XMSBOOLS[Byte1-001]:=XMSBOOLS[Byte1];
          XMSNAMES[Byte1-001]:=XMSNAMES[Byte1];
          XMSHANDLES[Byte1-001]:=XMSHANDLES[Byte1];
          Inc(AddL,XMSSIZES[Byte1]);
        End;
        XMSHANDLES[LastX]:=HandT;
        XMSOFFSETS[LastX]:=000;
        XMSBOOLS[LastX]:=false;
        XMSSIZES[LastX]:=000;
        XMSNAMES[LastX]:='';
        Exit;
      End
      Else
      ErrorOut('XMSFree: Name '+Name+' nicht in '+
      'BOOLscher Tabelle erfat oder gefunden',001,'',#000);
    End;
  End
  Else
  ErrorOut('XMSFree: Keine Belegung in '+
  'BOOLscher Tabelle erfat',001,'',#000);

End;




Procedure XMSFreeByHandle(XMSH: Hand);
Begin

  XMSFree(XMSNAMES[XMSH]);

End;




Function  XMSGetFree: IntL;
Var
  Byte0 : Byte;
  Long0 : IntL;

Begin

  Long0:=000;
  For Byte0:=000 To XMS Do
  If XMSBOOLS[Byte0]=BT Then
  Inc(Long0,XMSSizes[Byte0]);
  XMSGetFree:=XMSMyBlock*1024-Long0;

End;




Function  XMSGHand2(HNum: Byte): Byte;
Var
  Byte0 : Byte;

Begin

  For Byte0:=000 To XMS Do
  If HNum=XMSHANDLES[Byte0] Then
  If XMSBOOLS[Byte0] Then
  Begin
    XMSGHand2:=Byte0;
    Exit;
  End;
  ErrorOut('XMSGHand2: HNum nicht gefunden '+
  'oder nicht belegt',001,'',#000);

End;




Function  XMSGetHandle(Name: ST12;Size: IntL): IntM;
Var
  AddL  : IntL;
  Byte0 : Byte;
  Stri0 : ST80;
  Stri1 : ST80;

Begin

  For Byte0:=000 To XMS Do
  If XMSBOOLS[Byte0]=BT Then
  If XMSNAMES[Byte0]=Name Then
  Begin
    XMSGetHandle:=XMSHANDLES[Byte0];
    Exit;
  End;
  If Size>000 Then
  Begin
    AddL:=000;
    For Byte0:=000 To XMS Do
    Begin
      If XMSBOOLS[Byte0]=BF Then
      Begin
        If AddL+Size>XMSMyBlock*1024 Then
        Begin
          Str(Size,Stri0);
          Str(XMSMyBlock*1024-(AddL+Size),Stri1);
          EOut2('XMSGetHandle: Speicherberlauf '+
          '(Gewnscht:'+Stri0+' verfgbar: '+Stri1+')',001)
        End
        Else
        Begin
          XMSGetHandle:=XMSHANDLES[Byte0];
          XMSOFFSETS[Byte0]:=AddL;
          XMSNAMES[Byte0]:=Name;
          XMSSIZES[Byte0]:=Size;
          XMSBOOLS[Byte0]:=BT;
          Exit;
        End;
      End
      Else
      Inc(AddL,XMSSIZES[Byte0]);
    End;
    EOut2('XMSGetHandle: Kein XMS-Platz mehr frei',001);
  End
  Else
  XMSGetHandle:=-001;

End;




Function  XMSGetLast: IntM;
Var
  Byte0 : Byte;

Begin

  Byte0:=XMS;
  While (Byte0>000)
  And Not XMSBOOLS[Byte0] Do Dec(Byte0);
  If XMSBOOLS[Byte0] Then
  XMSGetLast:=Byte0
  Else
  XMSGetLast:=-001;

End;




Function  XMSTest(Name: ST12): Bool;
Var
  Byte0 : Byte;

Begin

  XMSTest:=BF;
  For Byte0:=000 To XMS Do
  If XMSBOOLS[Byte0]=BT Then
  If XMSNAMES[Byte0]=Name Then
  Begin
    XMSTest:=BT;
    Exit;
  End;

End;




END.
